//+------------------------------------------------------------------+
//|                                                GBPUSD_tsd_v1.mq4 |
//|                                                  Nicholas Barker |
//|                                                 www.apexpips.com |
//+------------------------------------------------------------------+
#property copyright "Nicholas Barker"
#property link      "www.apexpips.com"
#include <stdlib.mqh>
#define UP 0
#define DN 1
#define SL 0
#define TP 1

extern bool CloseAllTrades=false;
extern int PipsBeyond=1;
extern int RangeDays=14;
extern double lots=0.1;
extern int TZopentime = 5;
extern bool PM = true;
extern int TZ_GMTshift=5;
extern int Chart_GMTshift=0;
int ID=980999999999;


int tkt3[30];

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   start();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   int cnt=ordercnt();
   if(TimeFilter()){
      if(CloseAllTrades)CloseAll();
      if(cnt<1 && Ask >= target(UP) + PipsBeyond*Point){
         OpenOrder(Symbol(),OP_BUY,Ask-SLTP(SL)*Point,Ask+SLTP(TP)*Point);
      } 
      if(cnt<1 && Bid <= target(DN) - PipsBeyond*Point){
         OpenOrder(Symbol(),OP_SELL,Bid+SLTP(SL)*Point,Bid-SLTP(TP)*Point);
      }  
   }
   string k;
   if(CloseAllTrades)string warn= "Warning! - All trades will be closing on the "+Symbol();
   if(Hour()>12)datetime tm=CurTime()-(TZ_GMTshift*60*60)-(Chart_GMTshift*60*60)-(12*60*60); 
   else tm=CurTime()-TZ_GMTshift*60*60-Chart_GMTshift*60*60;
   k=k+StringConcatenate("\n\nEST = ",TimeToStr(tm,TIME_DATE|TIME_SECONDS),"\nADR = ",
   NormalizeDouble(RangeFinder(RangeDays)/Point,0),"\n",warn);
   Comment(k);
//----
   return(0);
  }
//+------------------------------------------------------------------+
/*
At 5PM EST: 

1- Close out any open positions 
2- Cancel any unexecuted orders 
3- Set an Entry Buy order 1 pip above previous high 
4- Set an Entry Sell order 1 pip below previous low 
5- Set stops and limits using the following guidelines: 

50 pip profit target, 25 pip stoploss if ADR ABOVE 200 
40 pip profit target, 20 stoploss if ADR BETWEEN 175 and 199 
30 pip profit target, 15 stoploss if ADR BELOW 175 

Do no trade if ADR is below 100 

*/

int CloseAll(){
   while(ordercnt()>0){
      int cnt=ordercnt();
      for(int i=0;i<cnt;i++){
         if(OrderMatch(i)){
            if(OrderType()==OP_BUY){
               OrderClose(OrderTicket(),OrderLots(),Bid,2,Red);
            }else{
               OrderClose(OrderTicket(),OrderLots(),Ask,2,Red);
            }
         }
      }
   }
   return(0);
}


double SLTP(int mode){
   double rng=RangeFinder(RangeDays)/Point;
   if(rng<175){
      if(mode==SL)return(15);else return(30);
   }
   if(rng>=175 && rng <200){
      if(mode==SL)return(20);else return(40);
   }
   if(rng>=200){
      if(mode==SL)return(25);else return(50);
   }
}
   

double target(int mode){
   if(mode==UP)return(iHigh(Symbol(),1440,0));
   if(mode==DN)return(iLow(Symbol(),1440,0));
}
   

double RangeFinder(int days){
   double rng;
   for(int i=0;i<days;i++){
      rng+=iHigh(Symbol(),1440,i)-iLow(Symbol(),1440,i);
   }
   return(rng/days);
}

bool TimeFilter(){
   if(PM)int hr = TZopentime + 12 + TZ_GMTshift + Chart_GMTshift;
   else hr = TZopentime + TZ_GMTshift + Chart_GMTshift;
   if(Hour()>=hr)return(true);
   return(false);
}

int OpenOrder(string symb,int buy,double sl,double tp){
   int ord;int c;
   while(ord<=0){
      RefreshRates();
      if(buy==OP_BUY)double price=MarketInfo(symb,MODE_ASK);else price=MarketInfo(symb,MODE_BID);
      ord=OrderSend(symb,buy,lots,price,2,sl,tp,"Simple_GBPUSD",ID,0,Red);
      if(ord>0)return(ord);
      else Print("Opening Error ",ErrorDescription(GetLastError()));
      if(c>10)return(-1);
      Sleep(100);
   }
}

int ordercnt(){
   int c;
   for(int i=0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS)){
         if(OrderSymbol()== Symbol()){
            tkt3[c]=OrderTicket();
            c++;
         }
      }
   }
   return(c);
}
//////////////////////////////////////////////////////////////////////////////////////////////
bool OrderMatch(int i){
   if(OrderSelect(tkt3[i],SELECT_BY_TICKET))return(true);else return(false);
}